<template>
  <div>
    <v-sheet>
      <v-card-title>
        <v-tooltip bottom v-model="show">
          <template v-slot:activator="{ attrs }">
            <v-text-field
              v-model="search"
              append-icon="mdi-magnify"
              label="Search"
              v-bind="attrs"
              single-line
              hide-details
            ></v-text-field>
          </template>
        </v-tooltip>
        <v-spacer></v-spacer>
        <v-btn
          class="ma-2 success"
          dark
          @click="handleCreateData"
          tile
          outlined
        >
          <v-icon>mdi-plus</v-icon>เพิ่ม
        </v-btn>
      </v-card-title>
      <hr
        role="separator"
        aria-orientation="horizontal"
        class="v-divider theme--light"
      />
      <v-data-table
        :headers="headers"
        :items="storesData"
        :items-per-page="10"
        item-key="id"
        multi-sort
        class="elevation-1"
      >
        <template #item.action="{ item }">
          <!-- <v-btn class="mr-1 mb-2" color="green darken-2" small dark>
            <v-icon small dark> mdi-image-multiple-outline </v-icon>
          </v-btn> -->
          <v-btn
            class="mr-1 mb-2"
            color="orange darken-2"
            small
            dark
            @click="handleEditdata(item)"
          >
            <v-icon small dark> mdi-pencil </v-icon>
          </v-btn>
          <v-btn
            class="mr-1 mb-2"
            color="red darken-2"
            small
            dark
            @click="handleDeldata(item)"
          >
            <v-icon small> mdi-delete </v-icon>
          </v-btn>
        </template>
      </v-data-table>
    </v-sheet>
  </div>
</template>
<script>
import Swal from 'sweetalert2'
import dateFormat from '@/components/functional/dateFormat'
import moneyFormat from '@/components/functional/moneyFormat'
import { mapGetters, mapActions, mapState } from 'vuex'
import _ from 'lodash'

import getExpenses from '~/mixins/getExpenses'

export default {
  watch: {
    async getExpensesStores() {
      this.storesData = this.$nuxt.$store.state.expensesstores.ExpensesStores
    },
  },
  components: {
    dateFormat,
    moneyFormat,
  },
  mixins: [getExpenses],
  data() {
    return {
      search: '',
      show: false,
      storesData: [],
      headers: [
        {
          text: 'ชื่อร้านค้า',
          align: 'center',
          value: 'name',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'รายละเอียด',
          value: 'detail',
          align: 'center',
          sortable: false,
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ที่ตั้ง',
          value: 'location',
          align: 'center',
          sortable: false,
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'เครื่องมือ',
          width: '20%',
          align: 'center',
          value: 'action',
          sortable: false,
          class: 'subtitle-2 font-weight-bold ',
        },
      ],
    }
  },
  computed: {},
  mounted() {},
  methods: {
    handleCreateData() {
      //เพิ่ม 1 (ListForm) แสดงฟอร์มสำหรับเพิ่มข้อมูล
      //เพิ่ม 1.1 (ListForm) Set Commit จัดการ EditItem ล่าสุด  เข้า State สำหรับ กดหนด Add/Edit
      this.$store.commit('SET_Expenses_Stores_EditItem', -1)
      //เพิ่ม 1.2 (ListForm) Set Commit จัดการ formExpensesList ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit(
        'SET_FORM_EXPENSES_STORES',
        !this.$nuxt.$store.state.expensesstores.formExpensesStores
      )
    },
    handleEditdata(val) {
      //แก้ไข 1 (ListForm) แสดงฟอร์มสำหรับแก้ไขข้อมูล

      this.editIndex = 1
      //แก้ไข 1.1 (ListForm) Set Commit จัดการ formExpensesList ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_Expenses_Stores_EditItem', 1)
      //เพิ่ม 1.2 (ListForm) Set Commit จัดการ formExpensesList ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_FORM_EXPENSES_STORES', true)
      //เพิ่ม 1.3 (ListForm) Set Commit จัดการ val เข้า  ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_Expenses_Stores_EditData', val)
    },
    handleDeldata(val) {
      //ลบ 1 (ListForm) แสดงฟอร์มสำหรับแก้ไขข้อมูล
      Swal.fire({
        title: 'คุณแน่ใจหรือไม่',
        text: 'คุณต้องการลบข้อมูลนี้',
        icon: 'warning',
        showCancelButton: true,
        cancelButtonColor: '#0288D1',
        confirmButtonColor: '#D32F2F',
        cancelButtonText: 'ยกเลิก',
        confirmButtonText: 'ใช่, ลบข้อมูล',
      }).then((result) => {
        if (result.isConfirmed) {
          //ลบ 1 (ListForm) dispatch พร้อม parameter "val" ไปยัง Fnc ลบข้อมูล
          this.$store.dispatch('delDataexpensesStore', val).then(() => {
            Swal.fire('ลบข้อมูล', 'คุณได้ลบข้อมูลเรียบร้อยแล้ว', 'success')
          })
        }
      })
    },
  },
}
</script>
<style scoped>
.v-sheet {
  border-radius: 4px !important;
  border: thin solid rgba(0, 0, 0, 0.12);
  border-width: 2px;
  background-color: #fff;
}
</style>
